//#include "aboutMsg.h"
#include<list>
#include<string>
#include<vector>
#include<stack>
#include<sstream>
#include<bitset>
#include<iterator>
/************************************************************************/
/*                                                                      */
/************************************************************************/
#include <windows.h>
#include <conio.h>
#include <stdio.h>
#include <iostream>

#define SystemBasicInformation       0
#define SystemPerformanceInformation 2
#define SystemTimeInformation        3

#define Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart))
/************************************************************************/
/*                                                                      */
/************************************************************************/

using namespace std;
const int g_szId=200;
const int g_szBufMap=100;
const int g_szRecvBuf=200;
const int g_szTempBuf=200;
const int g_szbitMap=2048;
////////////////////////////////////////////////////

string  int2str( int  num)
{
	if (num  ==   0 )
		return   " 0 " ;

	string  str  =   "" ;
	int  num_  =  num  >   0   ?  num :  - 1   *  num;

	while (num_)
	{
		str  =  ( char )(num_  %   10   +   48 )  +  str;
		num_  /=   10 ;
	} 

	if (num  <   0 )
		str  =   " - "   +  str;

	return  str;
} 

int  str2int( string  str)
{
	int  i,len  =  str.size(),num  =   0 ;

	i  =   0 ;   
	if (str[ 0 ]  ==   ' - ' )
		i  =   1 ;

	while (i  <  len)
	{
		num  =  num  *   10   +  ( int )(str[i]  -   ' 0 ' );
		i ++ ;
	} 

	if (str[ 0 ]  ==   ' - ' )
		num  *=   - 1 ;

	return  num;
} 

string getNextElem(char *&ch,int &i){//õһԪأ< >֮ڵֵ
	if(i>=(strlen(ch)-1))return "";///////////////////////////////////////////////////////////
	int j=i;string str;
	while(ch[j]!='<')j++;
	i=++j;
	while(ch[j]!='>')j++;str.append(ch,i,j-i);
	i=j;
	return str;
}
string getNextCont(char *&ch,int &i){//õһݣ> <֮ڵֵ
	if(i>=strlen(ch)-1)return "";///////////////////////////////////////////////////////////
	int j=i;string str;
	while(ch[j]!='>')j++;
	i=++j;
	while(ch[j]!='<')j++;str.append(ch,i,j-i);
	i=j;
	return str;
}
int getSN(char *&ch){//RTPȡSequence Number
	void *ch1;
	unsigned int a;
	int m=0xFFFF0000,n=0;
	ch1=ch;
	unsigned int x=(*(unsigned int *)ch1) & m;
	x=x>>16;
	a=x;a=a>>8;
	x=x & 0x000000FF;
	x=x<<8;
	x=x | a;

	return x;
}
/////////////////////////////////////////////////////////



struct ChGroup{
	ChGroup();
	string name;
	vector<string> vectCh;
	void clear();
};
ChGroup::ChGroup(){
	name="";
}
void ChGroup::clear(){
	name.clear();
	vectCh.clear();
}
class Channels{
public:
	Channels(){};
	Channels(char *&ch);//һstringChannels;
	void assign(char *&ch);//һstringChannels;
private:
	vector<ChGroup> vectGr;	
};
Channels::Channels(char *&ch){
	assign(ch);
}
void Channels::assign(char *&ch){
	int i=0,j=0;
	string s1,s2;
	s1=getNextElem(ch,i);s2=getNextCont(ch,i);
	//if(s2.empty())
	stack<string> s;
	s.push(s1);
	ChGroup g;
	while(!s.empty()){
		s1=getNextElem(ch,i);s2=getNextCont(ch,i);
		if(s1!="/Group"){
			if(!s2.empty()){
				g.vectCh.push_back(s2);
			}
			else if(s1.substr(0,5)=="Group"){//compare function return 0 if equal,this is unusual

				g.name=s1.substr(s1.find_first_of("\"")+1,s1.length()-s1.find_first_of("\"")-1);
			}
			else if(s1=="/Channels"){
				s.pop();
				//break;
			}
		}
		else{
			vectGr.push_back(g);
			g.clear();
		}
	}
}
class ChannelInfos{
};

class Neighbor{
public:
	Neighbor();
	virtual ~Neighbor();

public:
	// --- neighbor info ---
	string id;
	string ip;
	int port;

	// --- socket info ---
	SOCKET sock;
	bool bChoked;
	bool bInterested;
	//bool bUnchoke;

	// --- content info ---
	int bufBase;
	string bufMap;

	// --- transfer assist ---
	//char* recvBuf;
	//char* tempBuf;
	int tempBufIndex;
	int strLen;
	//Neighbor* pNeighbor;
	//int packetIndex;
	//stack<string> s;

	// --- transfer measure ---
	//double rate;
	//int amount;

	// --- timer assist ---
	//int tRespond;
	//int tLife;
	//int reqIndex;

	void clear();
};
// Neighbor member functions
Neighbor::Neighbor()
: sock(0)
, bChoked(FALSE)
, bInterested(TRUE)
//, bUnchoke(TRUE)
, bufBase(INT_MIN)
, tempBufIndex(0)
, strLen(0)
//, pNeighbor(NULL)
//, rate(0)
//, amount(0)
//, tRespond(0)
//, tLife(0)
//, reqIndex(-1)
{
	// --- id ---
	id = new char[g_szId];

	// --- socket ---
	closesocket(sock);//ΪʲôʱҪclose

	// --- buffer map ---
	//bufMap = new char[g_szBufMap];
	//ZeroMemory(bufMap, g_szBufMap);

	// --- receive buffer ---
	//recvBuf = new char[g_szRecvBuf];

	// --- temp buffer ---
	//tempBuf = new char[g_szTempBuf];
}

Neighbor::~Neighbor()
{
	// --- Release id ---
	//cout<<" 123 "<<endl;
	clear();
	if(!id.empty())id.clear();

	// --- Release buffer map ---
	//if(bufMap)
	//	delete [] bufMap;
	bufMap.clear();
	///closesocket(sock);
	// --- Release receive buffer ---
	//if(recvBuf)
	//	delete [] recvBuf;

	// --- Release temp buffer ---
	//if(tempBuf)
	//	delete [] tempBuf;

	// --- Release temp neighbor ---
	//	if(pNeighbor)
	//		delete pNeighbor;
}



void Neighbor::clear(){
	id="";ip="";port=-1;
}
class Neighbors{
public:
	Neighbors(){};
	~Neighbors();
	bool add(Neighbor &n);//NeighborϢӵNeighborList;
	bool rmChoked();//ɾNeighbor;
	void append(char *&ch);
	bool existed(string str);//stringʾipǷNeighborsУ
	void createSock();//socket,neighborssock;
public:
	list<Neighbor> NeighborList;
	vector<SOCKET> vectSK;//socketڴ˹
	vector<bool> vectUsage;//socketǷã
};
/*Neighbors::Neighbors(){

}*/
Neighbors::~Neighbors(){
	//while(!NeighborList.empty())NeighborList.pop_back();
	//delete NeighborList;
	NeighborList.clear();
	vector<SOCKET>::iterator Iter;
	for(Iter=vectSK.begin();Iter!=vectSK.end();Iter++);
	closesocket( (*Iter) );
}
bool Neighbors::add(Neighbor &n){
	NeighborList.push_back(n);
	return true;
}
bool Neighbors::rmChoked(){
	list<Neighbor>::iterator li=NeighborList.begin();
	while(li!=NeighborList.end()){
		//if choked==true,then remove this neighbor;/////////////////////////////////////////////
		if(li->bChoked==true)NeighborList.erase(li);
		li++;
	}
	return true;
}



void Neighbors::append(char *&ch){
	string s1,s2;
	int i=0;
	s1=getNextElem(ch,i);s2=getNextCont(ch,i);
	if(s1.compare("Neighbors"))return;
	Neighbor n;
	stack<string> s;s.push(s1);
	stringstream stream;
	while(!s.empty()){
		s1=getNextElem(ch,i);s2=getNextCont(ch,i);
		if(s1=="IPv4")n.ip=s2;
		else if(s1=="port"){
			stream.clear();
			stream<<s2;
			stream>>n.port;
		}
		else if(s1=="name")n.id=s2;
		else if(s1=="/Neighbor"){
			NeighborList.push_back(n);
			n.clear();
		}
		else if(s1=="/Neighbors")s.pop();
	}

}

bool Neighbors::existed(string str){//stringʾipǷNeighborsУ
	list<Neighbor>::iterator Iter;
	for(Iter=NeighborList.begin();Iter!=NeighborList.end();Iter++){
		if((*Iter).ip==str)return true;
	}
	return false;
}
void Neighbors::createSock(){//socket,neighborssock;
	list<Neighbor>::iterator Iter;int i=0;
	int x=1024*1024;
	for(Iter=NeighborList.begin();Iter!=NeighborList.end();Iter++){
		vectSK.push_back(socket(AF_INET,SOCK_STREAM,0));
		(*Iter).sock=vectSK[i++];
		vectUsage.push_back(true);
		setsockopt((*Iter).sock,SOL_SOCKET,SO_RCVBUF,(const char*)&x,sizeof(x));
	}
}

/************************************************************************/
/* ´붨һ⵱ǰcpuʵ                              */
/************************************************************************/
typedef struct
{
	DWORD dwUnknown1;
	ULONG uKeMaximumIncrement;
	ULONG uPageSize;
	ULONG uMmNumberOfPhysicalPages;
	ULONG uMmLowestPhysicalPage;
	ULONG uMmHighestPhysicalPage;
	ULONG uAllocationGranularity;
	PVOID pLowestUserAddress;
	PVOID pMmHighestUserAddress;
	ULONG uKeActiveProcessors;
	BYTE bKeNumberProcessors;
	BYTE bUnknown2;
	WORD wUnknown3;
} SYSTEM_BASIC_INFORMATION;

typedef struct
{
	LARGE_INTEGER liIdleTime;
	DWORD dwSpare[76];
} SYSTEM_PERFORMANCE_INFORMATION;

typedef struct
{
	LARGE_INTEGER liKeBootTime;
	LARGE_INTEGER liKeSystemTime;
	LARGE_INTEGER liExpTimeZoneBias;
	ULONG uCurrentTimeZoneId;
	DWORD dwReserved;
} SYSTEM_TIME_INFORMATION;

typedef LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG);

PROCNTQSI NtQuerySystemInformation;

class CpuUsedPercent
{
public:
	CpuUsedPercent();
	~CpuUsedPercent(){};
	int getcpupercent(int interval,int n);		//һѭϵÿinterval/1000жϵǰcpuǷСn%Сڣ1,򷵻0-1

private:
	SYSTEM_PERFORMANCE_INFORMATION SysPerfInfo;
	SYSTEM_TIME_INFORMATION SysTimeInfo;
	SYSTEM_BASIC_INFORMATION SysBaseInfo;
	double dbIdleTime;
	double dbSystemTime;
	LONG status;
	LARGE_INTEGER liOldIdleTime ;
	LARGE_INTEGER liOldSystemTime ;
};

CpuUsedPercent::CpuUsedPercent()
{
	LARGE_INTEGER liOldIdleTime = {0,0};
	LARGE_INTEGER liOldSystemTime = {0,0};
}

int CpuUsedPercent::getcpupercent(int interval, int n)
{
	NtQuerySystemInformation = (PROCNTQSI)GetProcAddress(GetModuleHandle((LPCTSTR)"ntdll"),"NtQuerySystemInformation");

	if (!NtQuerySystemInformation)  return -1;

	// ϵͳеǰĴ
	status = NtQuerySystemInformation(SystemBasicInformation,&SysBaseInfo,sizeof(SysBaseInfo),NULL);
	if (status != NO_ERROR)  return -1;

	while(!_kbhit())
	{
		// µϵͳʱ
		status = NtQuerySystemInformation(SystemTimeInformation,&SysTimeInfo,sizeof(SysTimeInfo),0);
		if (status!=NO_ERROR)   return 0;

		// µCPUĿʱ(idle time)
		status = NtQuerySystemInformation(SystemPerformanceInformation,&SysPerfInfo,sizeof(SysPerfInfo),NULL);
		if (status != NO_ERROR)  return 0;

		if (liOldIdleTime.QuadPart != 0)
		{
			// CurrentValue = NewValue - OldValue
			dbIdleTime = Li2Double(SysPerfInfo.liIdleTime) - Li2Double(liOldIdleTime);
			dbSystemTime = Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(liOldSystemTime);

			// CurrentCpuIdle = IdleTime / SystemTime
			dbIdleTime = dbIdleTime / dbSystemTime;

			// (CPUʵļ㹫ʽ)CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
			dbIdleTime = 100.0 - dbIdleTime * 100.0 / (double)SysBaseInfo.bKeNumberProcessors + 0.5;

		}

		if((UINT)dbIdleTime<=n)
		{
			return 1;
		}
		// store new CPU's idle and system time
		liOldIdleTime = SysPerfInfo.liIdleTime;
		liOldSystemTime = SysTimeInfo.liKeSystemTime;

		//˯intervalʱ
		Sleep(interval);

	}
	return 0;
}


struct RTP{
	RTP(){}
	RTP(char *&ch);
	~RTP();
	//string RTPstr;
	char RTPstr[1331];
	int SN;
	void get_SN(char *&ch);
};
void RTP::get_SN(char *&ch){
	void * ch1;
	unsigned int a;
	int m=0xFFFF0000,n=0;
	ch1=ch;
	unsigned int x=(*(unsigned int *)ch1) & m;
	x=x >> 16;
	a=x;a=a >> 8;
	x=x & 0x000000FF;
	x=x << 8;
	x=x | a;
	SN=x;
}
RTP::RTP(char *&ch){
	//RTPstr.append(ch,0,1331);//
	memcpy(RTPstr,ch,1331);
	get_SN(ch);
}
RTP::~RTP(){
	//delete [] RTPstr;
}
class RTPBuf{
public:
	RTPBuf();
	~RTPBuf();
	bool checkNeeded(); /*RTPеRTP SNǷȱʧİȱʧİ뵽NeededУ*/
	void add(char *&ch);/*Ӱ,ҪȼbitMap,˰ǷУû룬bitset.*/
	void Send2Player(SOCKET &sk,SOCKADDR_IN &ska);//windowsizertp
	int checkRTPBuf(char *&ch);				/*ܵһcpu¼ϵͳʱRTPǷȱʧİ*/
	int ReqBuf(char *&ch);					/*ݰݰsnŴԼneighborlistеǰreqneighbornumھӦݰ*/
	int ReqBuf2(Neighbors  n ,int sn);      /*ڼneighborlistеǰreqneighbornumھ󲻵ӦݰʱneighborlistѰûжӦİ*/
	string ReqPacket(Neighbors n,int start, int reqNeighborNum,Neighbor iter); /*snŴ*/
	//void RefreshNeighbor(Neighbors n);    /*ˢneighborlistкеİneighborpeer뵽ǰ棬ŻЧʣʵǺʵ֣ļpeer֮ϵͳȼ˲Ż*/
	void Send2Peer(int SN,SOCKET &sk);
public:
	string name;        //Ŀ
	int reqNeighborNum; //õʱھneighborlistһϵͳʱˢneighborlistõھpeerǰʵϵRefreshNeighbor
	int SNBase;
	int WindowSize;//bitMap±Ϊ׼Եֵ63ʱʵ64.
	deque<RTP> Buf;
	int BufIter;//ʾѭBufʼַ;
	int seriesMax;//,ﵽWindowSizeʱţ
	vector<int> Needed;//洢ȱʧİҪ
	bitset<g_szbitMap> bitMap;//ʹλͼ鿴ǰȡİ1ʾȡð0ʾȱʧ
	bool RTPexisted(int SN);//жǷڸRTP
};
RTPBuf::RTPBuf():Buf(g_szbitMap){
	seriesMax=0;
	SNBase=0;
	WindowSize=63;
	//for(int i=0;i<g_szbitMap;i++)bitMap[i]=0;
	BufIter=0;

	//Buf.resize(g_szbitMap);
}
RTPBuf::~RTPBuf(){
	Buf.erase(Buf.begin(),Buf.end());
	Needed.clear();
	//bitMap
}
void RTPBuf::add(char *&ch){
	int SN=getSN(ch);
	if(SNBase==0){SNBase=SN;seriesMax=0;}
	if(SN>=SNBase && SN<(SNBase+g_szbitMap) ){//жSequence NOڿɽܷΧ֮
		if(!RTPexisted(SN)){//˰ڣ
			Buf[(BufIter+SN-SNBase)%g_szbitMap].SN=SN;
			memcpy(Buf[(BufIter+SN-SNBase)%g_szbitMap].RTPstr,ch,1331);
			bitMap[SN-SNBase]=1;//ôλΪ1
		}
		while(bitMap.test(seriesMax+1))seriesMax++;//seriesMax;
	}
}
void RTPBuf::Send2Player(SOCKET &sk,SOCKADDR_IN &ska){//windowsizertp
	if(seriesMax>WindowSize){
		for(int i=0;i<WindowSize;i++){
			sendto(sk,Buf[BufIter].RTPstr,1328,0,(SOCKADDR*)&ska,sizeof(SOCKADDR));
		}
		BufIter=(BufIter+WindowSize+1)%g_szbitMap;
		SNBase=Buf[BufIter].SN;
		bitMap=bitMap>>(WindowSize+1);//λwindowsizeλƣ֤
		seriesMax=seriesMax-WindowSize-1;
	}
}


bool RTPBuf::checkNeeded() /*RTPеRTP SNǷȱʧİȱʧİ뵽NeededУ*/
{
	int n=0,mark=0;
	for(int i=0;i<bitMap.size();i++)//λͼ
	{
		if(bitMap[i]==0)
		{
			Needed[n++]=i+SNBase;//ȱʧİsnŴ洢Needed
			mark=1;
		}
	}
	if(mark==1)
		return true;
	return false;
}

/*void RTPBuf::RefreshNeighbor(Neighbors n)  ˢneighborlistкеİneighborpeer뵽ǰ棬ŻЧʣʵǺʵ֣ļpeer֮ϵͳȼ˲Ż
{
㷨˼:neighborlistÿneighbor¼ÿneighborλͼͣÿѡȡλͼͣӦĵneighborlist
øλͼΪ0ѭreqneighbornumΣˢneighborlist
int total=0;
int i;
vector<int> max;
list<Neighbor>::iterator iter;	
iter=n.NeighborList.begin();
while(iter!=n.NeighborList.end())//ÿneighborλͼ
{
for(i=0;i<g_szbitMap;i++)
total+=(*iter).bufMap[i];
max.push_back(total);
total=0;
}
int biggest=0;
for(i=0;i<reqNeighborNum;i++)//ÿѡȡλͼͣٵøλͼΪ0
{
for(int j=1;j<max.size();j++)
{
if(max[biggest]<max[j])
biggest=j;
max[biggest]=0;
}	

}
}*/

int RTPBuf::ReqBuf(char *&ch) /*ݰݰsnŴԼneighborlistеǰreqneighbornumھӦݰ*/
{
	Neighbors *neighbors=new Neighbors();
	neighbors->append(ch);
	if(neighbors->NeighborList.empty()==true)
		return -1;
	if(neighbors->NeighborList.size()<reqNeighborNum) //reqNeighborNumֵ
		reqNeighborNum=neighbors->NeighborList.size();
	list<Neighbor>::iterator iter;	
	iter=neighbors->NeighborList.begin();
	int i=0;
	int err;
	int mark=1;
	while(reqNeighborNum!=0)  //ȱʧİ㷨ǣȵĶǰreqNeighborNumneighbor󣬱1,reqNeighborNum+1.....Ե2neighbor󣬶ڸneighborûеĻֱҵиðneighbor
	{
		SOCKADDR_IN sd;
		sd.sin_addr.S_un.S_addr  = inet_addr((*iter).ip.c_str());
		sd.sin_family			 = AF_INET; 
		sd.sin_port              = (*iter).port; 
		err=sendto((*iter).sock,ReqPacket(*neighbors,i++,reqNeighborNum,(*iter)).c_str(),strlen(ReqPacket(*neighbors, i++,reqNeighborNum,(*iter)).c_str()),0,(SOCKADDR *)&sd,sizeof(sd)); //neighborϢ
		if(err<=0)
		{
			cout<<"sending ReqPacket ERROR!!"<<endl;
			mark=0; 
		}
		iter++;
		reqNeighborNum--;
	}
	return mark;
}

string RTPBuf::ReqPacket(Neighbors n, int start,int reqNeighborNum, Neighbor iter)/*snŴ*/
{
	if(Needed.size()==0)
		return NULL;
	string ReqContent="<RTPRequest><channel>"+name+"</channel><SN>";//ĸʽͬxmlĸʽƣsnsnַ֮aΪ
	for(int i=start;i<Needed.size();i+=reqNeighborNum)
	{
		if(iter.bufMap[Needed[i]-iter.bufBase]==1)  //neighborиð,򽫸snż뵽Ϣ
		{
			ReqContent+=(char *)Needed[i];
			ReqContent+='a';
		}
		else
			if(ReqBuf2(n, Needed[i])<=0)  //ڸneighborûеĻֱҵиðneighbor
				cout<<"channel"<<name<<endl<<"sn :"<<Needed[i]<<"haven't been found!"<<endl;
	}
	ReqContent+="</SN></RTPRequest>";
	return ReqContent;
}


int RTPBuf::ReqBuf2(Neighbors n,int sn)  /*ڼneighborlistеǰreqneighbornumھ󲻵ӦݰʱneighborlistѰûжӦİ*/
{
	list<Neighbor>::iterator iter;	
	iter=n.NeighborList.begin();
	while(iter!=n.NeighborList.end())
	{
		if((*iter).bufMap[sn-(*iter).bufBase]==1)
		{
			string reqbuf="<RTPRequest><channel>"+name+"</channel><SN>";//
			reqbuf+=(char *)sn;
			reqbuf+="</SN></RTPRequest>";
			SOCKADDR_IN sd;
			sd.sin_addr.S_un.S_addr  = inet_addr((*iter).ip.c_str());
			sd.sin_family			 = AF_INET; 
			sd.sin_port              = (*iter).port; 
			int err=sendto((*iter).sock,reqbuf.c_str(),strlen(reqbuf.c_str()),0,(SOCKADDR *)&sd,sizeof(sd));
			if(err<=0)
				cout<<"sending ReqPacket ERROR!!"<<endl;
			return 1;
		}
		iter++;
	}
	return 0;
}

int RTPBuf::checkRTPBuf(char *&ch)
{

	CpuUsedPercent *cup=new CpuUsedPercent();
	while(cup->getcpupercent(1000,2)==1)  //ÿһcpuʵ2%ʱʼɨ
	{
		if(this->checkNeeded()==FALSE)//ûȱʧ
			continue;
		this->ReqBuf(ch);     //ȱʧӦİ
	}
}

bool RTPBuf::RTPexisted(int SN){
	return bitMap.test(SN-SNBase);

}

void RTPBuf::Send2Peer(int SN,SOCKET &sk){//ͰSNpeer;
	if(RTPexisted(SN)){
		char* ch;
		char sendBuf[1342];
		ch=sendBuf;
		sprintf(sendBuf,"<RTPPacket>");
		ch=ch+11;
		memcpy(ch,Buf[BufIter+SN-SNBase].RTPstr,1328+3);//עSNλ
		send(sk,sendBuf,1342,0);
		cout<<SN<<endl;
	}
}

void parseReq(RTPBuf &rtp,char*& reqbuf,SOCKET &sk) //peer˷н,RTP SNԼеĶӦSNRTPԷ
{
	int i=0;
	string content="";
	getNextCont(reqbuf,i);
	getNextCont(reqbuf,i);
	content=getNextCont(reqbuf,i);
	content=content.c_str();
	if(content.size()<=0)
		return ;
	string temp="";
	int tem=0;
	for(int j=0;j<content.size();j++)
	{
		if(content[j]=='a')
		{
			temp.append(content,tem,j-tem);
			rtp.Send2Peer(str2int(temp),sk);
		}
		temp=j+1;
	}
}